diff --git a/src/match.c b/src/match.c
index 83e373275..9f9be8ae2 100644
--- a/src/match.c
+++ b/src/match.c
@@ -89,24 +89,20 @@ bool match_matches_window(Match *match, i3Window *window) {
 
 #define GET_FIELD_str(field) (field)
 #define GET_FIELD_i3string(field) (i3string_as_utf8(field))
-#define CHECK_WINDOW_FIELD(match_field, window_field, type)                                       \
-    do {                                                                                          \
-        if (match->match_field != NULL) {                                                         \
-            if (window->window_field == NULL) {                                                   \
-                return false;                                                                     \
-            }                                                                                     \
-                                                                                                  \
-            const char *window_field_str = GET_FIELD_##type(window->window_field);                \
-            if (strcmp(match->match_field->pattern, "__focused__") == 0 &&                        \
-                focused && focused->window && focused->window->window_field &&                    \
-                strcmp(window_field_str, GET_FIELD_##type(focused->window->window_field)) == 0) { \
-                LOG("window " #match_field " matches focused window\n");                          \
-            } else if (regex_matches(match->match_field, window_field_str)) {                     \
-                LOG("window " #match_field " matches (%s)\n", window_field_str);                  \
-            } else {                                                                              \
-                return false;                                                                     \
-            }                                                                                     \
-        }                                                                                         \
+#define CHECK_WINDOW_FIELD(match_field, window_field, type)                                                            \
+    do {                                                                                                               \
+        if (match->match_field != NULL) {                                                                              \
+            const char *window_field_str = window->window_field == NULL ? "" : GET_FIELD_##type(window->window_field); \
+            if (strcmp(match->match_field->pattern, "__focused__") == 0 &&                                             \
+                focused && focused->window && focused->window->window_field &&                                         \
+                strcmp(window_field_str, GET_FIELD_##type(focused->window->window_field)) == 0) {                      \
+                LOG("window " #match_field " matches focused window\n");                                               \
+            } else if (regex_matches(match->match_field, window_field_str)) {                                          \
+                LOG("window " #match_field " matches (%s)\n", window_field_str);                                       \
+            } else {                                                                                                   \
+                return false;                                                                                          \
+            }                                                                                                          \
+        }                                                                                                              \
     } while (0)
 
     CHECK_WINDOW_FIELD(class, class_class, str);
diff --git a/testcases/t/119-match.t b/testcases/t/119-match.t
index 64ffa4ed1..65c41f1f1 100644
--- a/testcases/t/119-match.t
+++ b/testcases/t/119-match.t
@@ -33,9 +33,7 @@ my $win = $content->[0];
 # not match it
 ######################################################################
 # TODO: specify more match types
-# we can match on any (non-empty) class here since that window does not have
-# WM_CLASS set
-cmd q|[class=".*"] kill|;
+# Try matching with an empty pattern since there isn't a WM_CLASS set.
 cmd q|[con_id="99999"] kill|;
 
 is_num_children($tmp, 1, 'window still there');
@@ -103,4 +101,18 @@ cmd '[title="^\w [3]$"] kill';
 wait_for_unmap $left;
 is_num_children($tmp, 0, 'window killed');
 
+######################################################################
+# check that we can match empty properties
+######################################################################
+
+$tmp = fresh_workspace;
+
+$left = open_window(name => 'class is empty', wm_class => '');
+ok($left->mapped, 'left window mapped');
+is_num_children($tmp, 1, 'window opened');
+
+cmd '[class="^$"] kill';
+wait_for_unmap $left;
+is_num_children($tmp, 0, 'window killed');
+
 done_testing;
